//+------------------------------------------------------------------+
//|                                                  FFT_Lanczos.mq5 |
//|                        Copyright 2014, MetaQuotes Software Corp. |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+


#property copyright "Copyright 2014, MetaQuotes Software Corp."
#property link      "http://www.mql5.com"
#property version   "1.00"
#property indicator_chart_window
#property indicator_buffers 1
#property indicator_plots   1
//--- plot FFT
#property indicator_label1  "FFT"
#property indicator_type1   DRAW_LINE
#property indicator_color1  clrRed
#property indicator_style1  STYLE_SOLID
#property indicator_width1  1
//--- indicator buffers
double         FFTBuffer[];
double Uno[],Due[];
#include <Canvas\Charts\LineChart.mqh>
CLineChart chart;
double AmpCos[],AmpSin[],Amp[];
bool firstLoop=true;

input int CanvasSize=800;

void OnDeinit(const int reason)
  {
         chart.Destroy();
  }


//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
//--- indicator buffers mapping
   SetIndexBuffer(0,FFTBuffer,INDICATOR_DATA);

   chart.VScaleParams(10,0,1);    //Sets parameters for vertical scale
   chart.ShowScaleTop(false);          // Sets visibility flag for top scale  
   chart.ShowScaleRight(false);        //Sets visibility flag for right scale 
   chart.ShowLegend();
   //chart.Filled();                   //adjusted parameters
   firstLoop=true;
   
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
//---
  
   int bars=Bars(Symbol(),0); 

     
   
     
  if(IsNewBar()==true || firstLoop==true) 
  {   
     

       if(!chart.CreateBitmapLabel("Canvas",10,10,CanvasSize,450))
     {
      Print("Error creating line chart: ",GetLastError());
      return(-1);
     }
 
   int Datas=400;
   ArrayResize(Amp,Datas);
 
   for(int i=0;i<Datas;i++) Amp[i]=MathMod(i,10);
   
   chart.SeriesAdd(Amp,"Ampiezza composita"); 
   
   firstLoop=false;
  }
   
   
   
   

   


   
//--- return value of prev_calculated for next call
   return(rates_total);
  }
//+------------------------------------------------------------------+


bool IsNewBar() 
 {
//--- memorize the time of opening of the last bar in the static variable
   static long   last_time=0;
//--- current time
   long   lastbar_time=SeriesInfoInteger(Symbol(),Period(),SERIES_LASTBAR_DATE);
//--- if it is the first call of the function
   if(last_time==0)
     {
      //--- set the time and exit
      last_time=lastbar_time;
      return(false);
     }
//--- if the time differs
   if(last_time!=lastbar_time)
     {
      //--- memorize the time and return true
      last_time=lastbar_time;
      return(true);
     }
//--- if we passed to this line, then the bar is not new; return false
   return(false);
 }